#include "redica.h"
#include <bits/stdc++.h>
using namespace std;
void gen(vector<int>& v,int n,int k,int s,int needsize)
{
    if(s<n||s>n*k) return;
    if(n==0)
    {
        submit(v);return;
    }
    for(long long i=max(1,s-(n-1)*k);i<=min(k,s-(n-1));i++)
    {
        v.push_back(i);
        gen(v,n-1,k,s-i,needsize);
        v.pop_back();
    }
}
bool check(int n,int k)
{
    long long num=1;
    for(long long i=1;i<=k;i++)
    {
        num*=n;
        if(num>1e10) return 0;
    }
    return 1;
}
void solve(int N,int K,int S)
{
    long long need=S;
    vector<int> v;
    long long rem=N;
    vector<int> v1;
    for(long long i=1;i<=N;i++)
    {
        v1.push_back(1);
    }
    submit(v1);
    while(1)
    {
        if(check(K,rem))
        {
            gen(v,rem,K,need,N);
        }
        int x=query();
        v.push_back(x);
        need-=x;
        rem--;
    }
}
